#ifndef _GL_SDL_PRINT_LIB_
#define _GL_SDL_PRINT_LIB_


#define X_SPACING 10
#define Y_SPACING 16


char g_font_file[] = "fonts.bmp";
unsigned char *g_font_img;
unsigned char *g_font[256];


void init_fonts()
{
int i, j, off;
SDL_Surface *tmp;


tmp = IMG_Load( g_font_file );
if( tmp == NULL ) return;

g_font_img = (unsigned char *)malloc( 256*256 * sizeof(unsigned char) );
if(g_font_img == NULL) return;

{
	  unsigned char *dest = g_font_img;
	  unsigned char *src = (unsigned char *)tmp->pixels;

	  for(int off = 0; off < 256*256; off++)
		{
		  *dest = *src;
			dest++;
			src++;
		}
}

for(j=0, off=0; j<16; j++)
for(i=0; i<16; i++, off++)
 g_font[off] = g_font_img + i*16 + j*16*256;

}


int strlen13(char *string)
{
int i;
char *str;
 for (i=0, str = string; (*str!='\n') && (*str!='\0'); i++, str++);
 return i;
}



void blit_char(int x, int y, int index)
{
int i,j;
unsigned char *s = g_font[(index-32)&0xFF] + (16-X_SPACING)/2;
__int32 *d = g_MySurface + x + y*SCREEN_X;

 for(j=0; j<16; j++, s+=256-16, d+=SCREEN_X-16)
  for(i=0; i<16; i++, s++, d++)
    if(*s)// *d = 0xFFFFFF;
		 *d = blend_to_white(*d, *s);
		
		
}



void print(int x, int y, char *string, int set)	// Where The Printing Happens
{
int sx = x, 
    sy = y;	
int i,len;
char *str = string;
int cur_line = 0;

set &= 0x01;
	
// Leading CrLfs:
while(*str == '\n') { str++; cur_line++; sy += Y_SPACING; }

while ( (len = strlen13( str )) != 0 )
{

// String printing
if((unsigned int)sy < SCREEN_Y-Y_SPACING)
for(i=0; i<len; i++)
{
if((unsigned int)sx < SCREEN_X-X_SPACING)
 blit_char( sx, sy, *str );// Write The Text To The Screen

 str++;
 sx += X_SPACING;
}

// End of string:
if(str=='\0') break;

// CrLf:
if(*str=='\n') sx -= len * X_SPACING;
while(*str=='\n')
{
 str++; cur_line++;
 sy += Y_SPACING;
}

}

}





int SDL_printf(int x, int y, int set, char *fmt, ...)
{
 va_list argptr;
 int cnt;
 static char buffer[256];
 char *buf;
 int i;

///////
     va_start(argptr, fmt);

      cnt = vsprintf(buffer, fmt, argptr);

	  print(x, y, buffer, set);

     va_end(argptr);
///////
     return(cnt);
}




#endif

