/*

 Ray 1.0 - SDL window implementation

*/



#ifndef _LIB_SDLWINDOW
#define _LIB_SDLWINDOW




#include "draw24.h"






SDL_Surface  *g_SDL_buf;
__int32 *g_vbuf = NULL;
int g_x_res = 0;
int g_y_res = 0;
SDL_Event g_event;
bool  g_Keys[512];
bool  g_Key_readed[512];



bool get_key(int keysym)
{
keysym &= 0x1FF;

if( !g_Key_readed[keysym] )
	{
	 g_Key_readed[keysym] = true;
	 return true;
	}

return false;
}



// draws a pixel, color values given already packed into an __int32 value
void put_pixel32(int x, int y, __int32 color)
{
	*(g_vbuf + x + y*g_x_res) = color;
}

// draws a pixel, color values given with integers [0 - 255]
void put_pixeli(int x, int y, short r, short g, short b)
{
	*(g_vbuf + x + y*g_x_res) = RGB2INT(r,g,b);
}

// draws a pixel, color values given with FTYPEs [0.0 - 1.0]
void put_pixelf(int x, int y, FTYPE r, FTYPE g, FTYPE b)
{
    *(g_vbuf + x + y*g_x_res) = RGB2INT(r*255.0, g*255.0, b*255.0);
}



// Default: 32bpp images
__int32 *init_window(int x_res, int y_res)
{
char buf[64];

SDL_Surface *buffer=NULL;

//#ifndef DOUBLED_MODE
sprintf(buf,"Ray 1.0   %i x %i", x_res, y_res);
//#else
//sprintf(buf,"Ray 1.0   %i x %i", x_res/2, y_res/2);
//#endif

  SDL_Init(SDL_INIT_VIDEO); //initialize systems

  SDL_WM_SetCaption( buf , NULL); // icon: not working?
  
 // SDL_Event event ;//declare event variable



	if( SDL_Init(SDL_INIT_VIDEO) == -1 )
	{
#ifndef LINUX_COMPILER
		MessageBox( NULL, "Error executing 'SDL_Init(SDL_INIT_VIDEO)'", "Error", MB_OK );
#endif
		return NULL;
	}
	
	if( SDL_InitSubSystem(SDL_INIT_VIDEO) == -1 )
	{
#ifndef LINUX_COMPILER
		MessageBox( NULL, "Error executing 'SDL_InitSubSystem(SDL_INIT_VIDEO)'", "Error", MB_OK );
#endif
		return NULL;
	}
	
	if( ! (buffer = SDL_SetVideoMode(x_res, y_res, 32, MY_SDL_MODE))  )
	{
#ifndef LINUX_COMPILER
		MessageBox( NULL, "Error executing 'SDL_SetVideoMode()'", "Error", MB_OK );
#endif
		return NULL;
	}

/* Setup OK ! */


 g_vbuf = (__int32 *)buffer->pixels;
 g_x_res = x_res;
 g_y_res = y_res;
 g_SDL_buf = buffer;

 for(int i=0; i<512; i++)
 {
	 g_Keys[i] = false;
	 g_Key_readed[i] = true;
 }


  return ( (__int32 *)buffer->pixels );
}





bool handle_events()
{
		/* Check for events */
		while(SDL_PollEvent(&g_event)) // loops until there are no events left on the queue
		{  

			switch(g_event.type)
			{  
				case SDL_QUIT: return( true ); break;


          case SDL_MOUSEMOTION:
						/*
					alpha = -((g_event.motion.x / (FTYPE)SCREEN_X)-.5) * M_PI * 2.0;
					beta = ((g_event.motion.y / (FTYPE)SCREEN_Y)-.5) * 4.0 * M_PI;
					 beta=MIN(beta, M_PI/2.0 -.01);
					 beta=MAX(beta, -M_PI/2.0+.01);
					 */
				break;
				case SDL_KEYDOWN:  
					      g_Keys[ g_event.key.keysym.sym & 0x1FF] = true;  
							  g_Key_readed[ g_event.key.keysym.sym & 0x1FF ] = false;
							 break;
				case SDL_KEYUP:    g_Keys[ g_event.key.keysym.sym & 0x1FF] = 0;  break;

			}

		}

return false;

}



#endif

