/*

  Ray 1.0 - Item-type enumeration values

  Note: strictly bound to "parser.h"

*/



#ifndef _LIB_ENUM
#define _LIB_ENUM



// Canonical object types:
typedef enum {
// 1st degree:
 PLANE,
 BOX,
 TRIANGLE,
 MODEL,

 // 2nd degree:
 SPHERE,
 CYLINDER,
 CONE,
 QUADRIC,

// 3rd degree:
 TRILINEAR_CELL,
 CUBIC,

// 4th degree:
 BOX4,
 TORUS,
 TANGLE,
 TOOTH,
 QUARTIC,

// other shapes:
  METABALLS,
  CSG
} t_shape_enum;



/* Quartic surfaces presets: */

typedef enum {

} t_quartic_enum;


/* Material attributes: */

typedef enum {
 DUMMY,
 DIFFUSE,      // diffuse color
 SPECULAR,     // specular component
 TRANSPARENCY, // transparency (from 0.0 to 1.0)
 SHINYNESS,    // shinyness (from 0.0 to 1.0)
 IOR           // index of refraction
} t_material_enum;


/* Procedural texture types: */

typedef enum {

 TEX_PERLIN,
 TEX_XOR,
 TEX_CHECKER,
 TEX_PALETTE,

 TEX_NONE,

 TEX_IMAGE
} t_texture_enum;

#define TEX_IS_3D( tex )  ((tex) <= TEX_PALETTE)

/* Light types: */

typedef enum {
 AMBIENT,
 DIRECTIONAL,
 OMNI,
 SPOT,
 AREA,
 WIRE
} t_light_enum;



/* CSG operation types: */

typedef enum {
 ADD,  // A + B
 SUB,  // A - B 
 AND,  // A & B
 HOLE // (A - B) & A
} t_csg_enum;



typedef enum {
SOLVE_ALL,
SOLVE_ONE
} t_solver_enum;

#endif
