/*

  Ray 1.0 - image interpolation routines

*/
#ifndef _LIB_INTERPOLATE
#define _LIB_INTERPOLATE



// Quad edge dimension (in pixels) and shift needed
// to multiply/divide Fixed-point values
#define QUAD_DIM   8
#define QUAD_SHIFT 3

//
#define QUAD_NUM_X  ((SCREEN_X / QUAD_DIM)+1)
#define QUAD_NUM_Y  ((SCREEN_Y / QUAD_DIM)+1)


// Linear image Buffer total size
#define LB_LEN  (SCREEN_X * SCREEN_Y)
// Linear image Buffer line size
#define LB_OFF   SCREEN_X


t_pixel g_my_pixels[QUAD_NUM_X * QUAD_NUM_Y]; // TODO: optimize out memory usage!

t_point3d g_op;
__int32 g_bkg = 0x000000;


void quad_compute_delta(t_pixel *delta, t_pixel *start, t_pixel *end)
{
 FIX_TYPE *d = delta->values;
 FIX_TYPE *s = start->values;
 FIX_TYPE *e = end->values;

 for(int i=0; i < PIXEL_NUM_VARS; i++) 
 {
 // delta = (end - start) / QUAD_DIM
   //*d = ( *e - *s ) / QUAD_DIM;
	 //if(*e == *s) *d = 0; else
	 *d = ( *e - *s ) >> QUAD_SHIFT;

	 d++;
	 s++;
	 e++;
 }
}



void quad_fill(__int32 *start, __int32 color)
{
int i, j;

 for(j=0; j<QUAD_DIM; j++)
 {
   for(i=0; i < QUAD_DIM; i++)
   {
	 	 *start = color;
 		 start++;
	 }
	 start += SCREEN_X - QUAD_DIM;
 }


}



__int32 pixel2rgb(FIX_TYPE *v, __int32 *txt)
{ 
FIX_TYPE r, g, b;

__int32 col;


texture256_get_pixel( &r, &g, &b,  txt, v[6], v[7] );

 r = v[0] * r +  v[3];	 if(r > 255<<FIX_BITS) r = 255<<FIX_BITS;
 g = v[1] * g +  v[4];	 if(g > 255<<FIX_BITS) g = 255<<FIX_BITS;
 b = v[2] * b +  v[5];	 if(b > 255<<FIX_BITS) b = 255<<FIX_BITS;

 return(	 //RGB2INT(r, g, b)

	 // Light: "L", Material: "M"
	 // (Diffuse_L + Specular_L) * Diffuse_M
	 
	 ( (( b ) >> (FIX_BITS - 8*0 )) ) |
	 ( (( g ) >> (FIX_BITS - 8*1 )) & 0x00FF00 ) |
	 ( (( r ) >> (FIX_BITS - 8*2 )) & 0xFF0000 )

	 );
}




void quad_pixel_add( t_pixel *dst, t_pixel *val )
{
FIX_TYPE *d = dst->values;
FIX_TYPE *p = val->values;

	for(int i=0; i < PIXEL_NUM_VARS; i++)
	{
		*d += *p;
		d++;
		p++;
	}
}

/*
void asm_ptr()
{
	char *string = "Hello, Weirdo!$";
	
	_asm mov dx,string
	_asm mov ah,9
	_asm int 21h
}
*/



void quad_interpolate(__int32 *dst, 
											t_pixel *p0, t_pixel *p1,
											t_pixel *p2, t_pixel *p3 )
{
__int32 *v = dst;
__int32 col;
t_pixel pixel;
t_pixel start_x; // start values
t_pixel end_x;   // end values
t_pixel delta_x; // horizontal increment values
t_pixel delta_sy; // vertical increment values (start)
t_pixel delta_ey; // vertical increment values (end)

int i, j;

// TODO: needs optimizations 
if( p0->shape_id == p1->shape_id &&
    p2->shape_id == p3->shape_id &&
    p1->shape_id == p3->shape_id    )
{
// all background pixels:	
 if(p3->shape_id == 0) 
 {
	 quad_fill(dst, g_bkg );
   return;
 }
}
 else
{
/* TODO: recursion*/ quad_fill(dst, g_bkg);
 return;
}


/*
{
#define AAA FLOAT_2_FIX(.15)
FIX_TYPE *va;
FIX_TYPE *vb;

va = p0->values;
vb = p1->values;
if( ABS(va[0] - vb[0]) > AAA ||
    ABS(va[1] - vb[1]) > AAA ||
		ABS(va[2] - vb[2]) > AAA    ) { quad_fill(dst, g_bkg);  return; }
va = p1->values;
vb = p2->values;
if( ABS(va[0] - vb[0]) > AAA ||
    ABS(va[1] - vb[1]) > AAA ||
		ABS(va[2] - vb[2]) > AAA    ) { quad_fill(dst, g_bkg);  return; }
va = p2->values;
vb = p3->values;
if( ABS(va[0] - vb[0]) > AAA ||
    ABS(va[1] - vb[1]) > AAA ||
		ABS(va[2] - vb[2]) > AAA    ) { quad_fill(dst, g_bkg);  return; }
va = p3->values;
vb = p0->values;
if( ABS(va[0] - vb[0]) > AAA ||
    ABS(va[1] - vb[1]) > AAA ||
		ABS(va[2] - vb[2]) > AAA    ) { quad_fill(dst, g_bkg);  return; }
}

*/

start_x = *p0;
end_x   = *p1;

// Starting vertical delta:
quad_compute_delta( &delta_sy, p0, p2 );
// Ending vertical delta:
quad_compute_delta( &delta_ey, p1, p3 );


int l_off = LB_OFF - QUAD_DIM;


for(j=QUAD_DIM; j; j-- )
{

  quad_compute_delta( &delta_x,  &start_x, &end_x );

  pixel = start_x;

  for(i=0; i < QUAD_DIM; i++)
  {
    
    *v = pixel2rgb( pixel.values, pixel.texture );

	 quad_pixel_add( &pixel, &delta_x );

	 v++;
  }  // end "for(i)"


// Compute the next line's values: (TODO cycle optimization)
if(j)
{
 quad_pixel_add( &start_x, &delta_sy );

 quad_pixel_add( &end_x, &delta_ey  );

 v+=l_off;
}

} // end "for(j)"

}





void draw_quads(__int32 *buf, t_pixel *pixels, t_camera *c, t_scene *sc)
{
__int32 *v = buf;
t_pixel *p = pixels;
int i, j;

g_op = c->op;
g_bkg = RGBF2INT( sc->fog_color.r, sc->fog_color.g, sc->fog_color.b );


for(j=0; j < QUAD_NUM_Y-1; j++)
{

  for(i=0; i < QUAD_NUM_X-1; i++)
  {

    quad_interpolate( v,  p, p+1, p+0+QUAD_NUM_X, p+1+QUAD_NUM_X );

		v+=QUAD_DIM;

		p++;

  }
	p++;

	 // Handle the case in wich X resolution isn't a multiple of QUAD_DIM:
	  //  v += (SCREEN_X % QUAD_DIM);
	v+= SCREEN_X*(QUAD_DIM-1);

}

}





#endif


