/*

  Ray 1.0 - Main

  2004-2005 - Bosi Mathieu

*/




//#define LINUX_COMPILER




//#define DEBUG_LOG






#ifndef LINUX_COMPILER
 #include "SDL.h"
#else
 #include "SDL/SDL.h"
#endif

#include <math.h>
#include <stdio.h>


#ifndef LINUX_COMPILER
 #define WINDOWS_LEAN_AND_MEAN
  #include <windows.h> 
#else
  #include <unistd.h>
  #include <stdlib.h>
  #define __int32 int
#endif


//////////////////////////////////////////////


//#define MY_SDL_MODE  SDL_FULLSCREEN
#define MY_SDL_MODE  SDL_ANYFORMAT

//#define WIDE_SCREEN


// Type for floating point operations
#define FTYPE float
#define SQRT(n) sqrtf(n)




//#define SCREEN_X (int)(512)
#define SCREEN_X (int)(640)

#ifdef WIDE_SCREEN
 #define SCREEN_Y (int)((SCREEN_X/16)*10)
#else
 #define SCREEN_Y (int)((SCREEN_X/4)*3)
#endif


// Visualization quality flags/values:
bool g_double_pixels = false;
bool g_use_fogging   = true;
bool g_no_lighting   = false;
bool g_cast_shadows  = true;
bool g_soft_shadows  = false;

bool g_use_texturing      = false;
bool g_modulate_texturing = false;
bool g_bilinear_texturing = false;

int g_num_recursions = 0;
int g_quality_parameter = 25;


bool g_show_rects = false;
bool g_animate = false;
bool g_quit = false;




/////////////////////////////////////////////





/* Global application-data: */
FTYPE g_fvals[16];
int   g_unknown = 0;
int   g_frames = 0;
float g_anim = 0.0;
Uint32 g_old_time = 0;
float g_fps = 0.0;


char *g_texture_file[] =
{
 "tess_02.jpg",
 "tess_04.jpg",
 "wood_01.jpg",
 "tess_03.jpg",
 "tess_01.jpg",
 "tess_05.jpg"
};
int g_num_texture_files = 6;







/* Include libraries: */
#include "mathconsts.h"
#include "fixed.h"
#include "enum.h"
#include "log.h"
#include "math3d.h"

#include "draw24.h"
#include "textures.h"
#include "SDLprintf.h"
#include "SDLwindow.h"


#include "perlin.h"
#include "noise.h"

#include "solvers.h"
#include "billboard.h"

#include "roots3and4.h"
#include "colors.h"
#include "lights.h"
#include "materials.h"

#include "viewport.h"
#include "camera.h"
#include "scene.h"

#include "raytracer.h"

#include "interpolate.h"

#include "render.h"

#include "timer.h"











void init_scene( t_scene *sc )
{

load_textures( g_texture_file, g_num_texture_files );

scene_free( sc, 60,  .9,.9,.9);


//scene_add_light( sc, make_ambient_light(.2, .2, .2) );
scene_add_light( sc, make_ambient_light(.5, .4, .4) );
//scene_add_light( sc, light_set_color(make_directional_light(0,-1,.5), 1,1,.95) );
//scene_add_light( sc, light_set_color(make_spot_light(0,-.9,-5,0,-2,0,30,10), 1,.9,.8) );

//scene_add_light( sc, light_set_color(make_spot_light(-2,2,-2, 0,0,2, 30, 10), 1,.9,.8)  );
scene_add_light( sc, light_set_color(make_omni_light(4,4,4), 1,1,1) );

scene_add_light( sc, light_set_color(make_spot_light(-4, 3, 4,  1,0,-1, 25,25), 1,.8,.7)  );

//scene_add_light( sc, light_set_color(make_spot_light( 4, 3, 4,  -1,0,-1, 15,5), 1,0,0)  );
//scene_add_light( sc, light_set_color(make_spot_light( 0, 4, -4,  -1,1.5,-3, 20,10), 0,0,1)  );



//set_color3f( &g_cur_light->color, 1,0,0 );

//scene_add_light( sc, make_omni_light(2,2,0) );

//set_color3f( &g_cur_light->color, );




scene_add_shape( sc, BOX );
//scene_add_shape( sc, CONE );
//scene_add_shape( sc, SPHERE );
 g_current_shape->material->tex = TEX_PERLIN;



scene_add_shape( sc, TANGLE );
 g_current_shape->material->tex = TEX_IMAGE;



g_fvals[0] = 0; g_fvals[1] = -3; g_fvals[2] = 0;
g_fvals[3] = 0; g_fvals[4] = 1; g_fvals[5] = 0;
scene_add_shape( sc, PLANE );
 g_current_shape->material->tex = TEX_CHECKER;


/*
 scene_add_shape( sc, BOX );
 g_current_shape->material->tex = TEX_PERLIN;
 */


g_fvals[0] = -1; g_fvals[1] = 2; g_fvals[2] = 0;
g_fvals[3] = -1; g_fvals[4] = 0; g_fvals[5] = -1;
g_fvals[6] = 1;  g_fvals[7] = -1; g_fvals[8] = 2;
scene_add_shape( sc, TRIANGLE );
 g_current_shape->material->tex = TEX_XOR;


scene_add_shape( sc, TRILINEAR_CELL );
 g_current_shape->material->tex = TEX_IMAGE;


 g_fvals[0] = .4; // r
 g_fvals[1] = 2.0; // R
 scene_add_shape( sc, TORUS );




scene_add_shape( sc, BOX4 );

g_current_shape->material->tex = TEX_IMAGE;

//scene_add_shape( sc, SPHERE );

//scene_add_shape( sc, CONE );

//scene_add_shape( sc, CYLINDER );




/*
 g_fvals[0] = .05; // r
 g_fvals[1] = 1.5; // R
 scene_add_shape( sc, TORUS );
*/


// 1-sheet Hyperboloid
 g_fvals[0] = 1; // x
 g_fvals[1] = 0; // y
 g_fvals[2] = 1; // z
 g_fvals[3] = 1;
 scene_add_shape( sc, QUADRIC);


/*
// 2-sheets Hyperboloid
 g_fvals[0] = 1; // x
 g_fvals[1] = -1; // y
 g_fvals[2] = 1; // z
 g_fvals[3] = -1;
 scene_add_shape( sc, QUADRIC);
*/




 g_fvals[0] = 1; // x
 g_fvals[1] = 1; // y
 g_fvals[2] = 1; // z
 g_fvals[3] = 1;
 scene_add_shape( sc, QUADRIC);
 g_current_shape->material->tex = TEX_IMAGE;


 
 g_fvals[0] = 1; // x
 g_fvals[1] = 1; // y
 g_fvals[2] = 1; // z
 g_fvals[3] = 2*2;
 scene_add_shape( sc, QUADRIC);
 g_current_shape->material->tex = TEX_IMAGE;


/*
g_fvals[0] = 0; g_fvals[1] = 0; g_fvals[2] = -12;
g_fvals[3] = 0; g_fvals[4] = 0; g_fvals[5] = 1;
scene_add_shape( sc, PLANE );
 g_current_shape->material->tex = TEX_NONE;
*/


//255.0/255.0, 140.0/255.0, 50.0/255.0 )


}





///////////////////////////////////
/*   MAIN:                       */
///////////////////////////////////



int main(int argc, char *argv[])
{
FTYPE a=0.0, b;
int i;
t_vector3d v;
FTYPE alpha = 0.0, beta=0.0, radius = 2.0;
FTYPE d_alpha = M_PI/10.0, d_beta=M_PI/10.0, d_radius = .05;




init_rand();
init_m();
for(i=0; i<256; i++) g_Keys[i] = false;


#ifdef DEBUG_LOG
start_log("log.txt");
#endif

// Initializes the window
init_window( SCREEN_X, SCREEN_Y );

init_fonts();

// set up drawing primitives LFB pointer
g_MySurface = g_vbuf;

#ifdef DEBUG_LOG
 printf("window initialized\n");
#endif

// Initializes the scene to be rendered
init_scene( &g_my_scene );


init_viewport( &g_my_camera.viewport, 0, 0, 1.0, 
							  -1.0,  1.0*(SCREEN_Y/(FTYPE)SCREEN_X),  
								 1.0, -1.0*(SCREEN_Y/(FTYPE)SCREEN_X), 
								 SCREEN_X, SCREEN_Y, g_vbuf );



nav_init( &g_my_nav, &g_my_camera );




//*** MAIN LOOP: ***
do{

if( g_animate ) a+=.025;






if(g_num_lights > 1)
{
 light_set_pos( g_my_scene.lights[1], cos(a*2.0)*4.0, sin(a*.8)*2.0 + 4.5, sin(a*3.5)*4.0  );
 //light_set_pos( g_my_scene.lights[1], -v.z, v.y, v.x  );

 light_set_at( g_my_scene.lights[1], sin(a)*4.0, 0, cos(a*.5)*4.0 );
 FTYPE cr,cg,cb,t;
 color_rainbow(&cr,&cg,&cb, a);
 //t=fabs(sin(a*1.5)); 
 t=1.0;
 cr*=t;cg*=t;cb*=t;
 
 light_set_color( g_my_scene.lights[2], cr, cg, cb);
 light_set_pos( g_my_scene.lights[2], cos(a*2.0)*5.0, 5, sin(a*4.0)*5.0 );
 light_set_at( g_my_scene.lights[2], cos(a)*4.0, 0, sin(a)*4.0 );
 g_my_scene.lights[2]->multiplyer = 1.5;
 
}




 i = 0;// BOX
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate( g_my_scene.shapes[i]->m, 0,2,6);

 m_scale( g_my_scene.shapes[i]->m, 2,2,2);
 m_rotate_y( g_my_scene.shapes[i]->m, -M_PI/4.0-a*2.0);
 m_rotate_x( g_my_scene.shapes[i]->m, a*1.1);


 i = 1; // TANGLE
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, 5,0,-5);
 m_rotate_x( g_my_scene.shapes[i]->m, a);
 m_rotate_z( g_my_scene.shapes[i]->m, -a*1.7);
 m_scale( g_my_scene.shapes[i]->m, .6,.6,.6);

 i = 2;//PLANE
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
// m_rotate_y( m, M_PI/3.0);
 m_scale( g_my_scene.shapes[i]->m, 6,1,6);


 i = 3; // TRI
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, -5,2,5);
 m_rotate_x( g_my_scene.shapes[i]->m, a*2.0);

 i = 4; // TRILIN
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, 5,1,4);
 m_scale( g_my_scene.shapes[i]->m, 4,4,4);
 m_rotate_y( g_my_scene.shapes[i]->m, -M_PI/4.0);
 m_translate(g_my_scene.shapes[i]->m, -.5,-.5,-.5);
 ((t_trilinear_cell *)(g_my_scene.shapes[i]->shape_data))->iso = sin(a*4.0)*.5+2.5;


 i = 5; // TORUS
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, -5,0,0);
 m_rotate_z( g_my_scene.shapes[i]->m, a*3.0);
 m_scale( g_my_scene.shapes[i]->m, 1,1.5,3);

 i = 6; // BOX4
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, 6,0,0);
 m_rotate_x( g_my_scene.shapes[i]->m, -a*3.0);
 m_scale( g_my_scene.shapes[i]->m, 2,2,1);


 i = 7; // HYP
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, 0,1.5,-5);
 m_rotate_y( g_my_scene.shapes[i]->m, M_PI/4.0);
 m_scale( g_my_scene.shapes[i]->m, 2,2,2);
 m_rotate_z( g_my_scene.shapes[i]->m, M_PI/2.0);

 i = 8; // SPHERE
 m_identity( g_my_scene.shapes[i]->m ); m_scale( g_my_scene.shapes[i]->m, 1.5,1.5,1.5 );
 m_translate(g_my_scene.shapes[i]->m, cos(a*3.0)*3.0 - 5, 0, sin(a*6.0)*2.4 );
 m_scale( g_my_scene.shapes[i]->m, .8,.8,.8);
 m_rotate_y( g_my_scene.shapes[i]->m, a*8.0);

/*
FTYPE *m;

 m = (FTYPE *)(g_my_scene.shapes[0]->m);// BOX
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, 0,2,6);

 m_scale( m, 2,2,2);
 m_rotate_y( m, -M_PI/4.0-a*2.0);
 m_rotate_x( m, a*1.1);


 m = (FTYPE *)(g_my_scene.shapes[1]->m); // TANGLE
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, 5,0,-5);
 m_rotate_x( m, a);
 m_rotate_z( m, -a*1.7);
 m_scale( m, .6,.6,.6);

 m = (FTYPE *)(g_my_scene.shapes[2]->m); //PLANE
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
// m_rotate_y( m, M_PI/3.0);
 m_scale( m, 6,1,6);


 m = (FTYPE *)(g_my_scene.shapes[3]->m); // TRI
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, -5,2,5);
 m_rotate_x( m, a*2.0);

 m = (FTYPE *)(g_my_scene.shapes[4]->m); // TRILIN
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, 5,1,4);
 m_scale( m, 4,4,4);
 m_rotate_y( m, -M_PI/4.0);
 m_translate(m, -.5,-.5,-.5);
 ((t_trilinear_cell *)(g_my_scene.shapes[i]->shape_data))->iso = sin(a*3.0)*.5+2.5;


 m = (FTYPE *)(g_my_scene.shapes[5]->m); // TORUS
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, -5,0,0);
 m_rotate_z( m, a*3.0);
 m_scale( m, 1,1.5,3);

 m = (FTYPE *)(g_my_scene.shapes[6]->m); // BOX4
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, 6,0,0);
 m_rotate_x( m, -a*3.0);
 m_scale( m, 2,2,1);


 m = (FTYPE *)(g_my_scene.shapes[7]->m); // HYP
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, 0,1.5,-5);
 m_rotate_y( m, M_PI/4.0);
 m_scale( m, 2,2,2);
 m_rotate_z( m, M_PI/2.0);

 m = (FTYPE *)(g_my_scene.shapes[8]->m); // SPHERE
 m_identity( m ); m_scale( m, 1.5,1.5,1.5 );
 m_translate(m, cos(a*3.0)*3.0 - 5, 0, sin(a*6.0)*2.4 );
 m_scale( m, .8,.8,.8);
 m_rotate_y( m, a*8.0);
*/

/************/
  g_quit = handle_events();

  // Renders the scene


  render_scene2( &g_my_camera, &g_my_scene, &g_my_pixels[0], g_vbuf,
		             QUAD_NUM_X, QUAD_NUM_Y, g_num_recursions );



for(i=1; i<g_my_scene.num_lights; i++)
 draw_light( g_my_scene.lights[i], &g_my_camera );

if( g_show_rects )
for(i=0; i<g_my_scene.num_objects; i++)
{
t_shape *sh = g_my_scene.shapes[i];

 t_clipping_rect *r = &g_my_scene.shapes[i]->clipping_rect;

 g_MyDrawColor32 = get_rgb( &g_my_scene.shapes[i]->material->diffuse );

 draw_rect( r->x_min, r->y_min, r->x_max, r->y_max );


t_point3d c = sh->corner;
int x, y;

t_point3d p;
c.x=0;
c.y=0;
c.z=0;

m_transform_point(sh->m, &c, &p);

camera_project_point_screen( &p, &g_my_camera,  &x, &y );

//g_MyDrawColor32 = 0xFF0f0f;
 g_MyDrawColor32 = get_rgb( &g_my_scene.shapes[i]->material->diffuse );

put_pixel_32(x, y+2);
put_pixel_32(x, y-2);
put_pixel_32(x+2, y);
put_pixel_32(x-2, y);
put_pixel_32(x, y+1);
put_pixel_32(x, y-1);
put_pixel_32(x+1, y);
put_pixel_32(x-1, y);
put_pixel_32(x, y);

}






if(g_frames % 12 == 0) 
{
 Uint32 tmp = SDL_GetTicks();
 g_fps = 12.0 * 1000.0 / (FTYPE)(tmp - g_old_time);
 g_old_time = tmp;
}

g_MyDrawColor32 = 0x000000;
fill_rect(0,0, SCREEN_X, 16, 128);
SDL_printf(0, 0, 0, "Time: %.2f, FPS: %.1f", (float)( (FTYPE)SDL_GetTicks()/1000.0 ), (float)g_fps );



 SDL_UpdateRect(g_SDL_buf, 0, 0, SCREEN_X, SCREEN_Y);
 g_frames++;








#ifdef DEBUG_LOG
 printf("scene rendered\n");
#endif



// Rendering controls:
   if( get_key(27) ) g_quit = 1;
   if( get_key(SDLK_1) )  g_show_rays  ^= 1; 
	 if( get_key(SDLK_2) )  g_double_pixels  ^= 1; 
	 if( get_key(SDLK_3) )  g_use_texturing  ^= 1; 
	 if( get_key(SDLK_4) )  g_modulate_texturing  ^= 1; 
	 if( get_key(SDLK_5) )  g_bilinear_texturing  ^= 1; 
   if( get_key(SDLK_6) )  g_use_fogging    ^= 1; 
   if( get_key(SDLK_7) )  g_no_lighting    ^= 1; 
   if( get_key(SDLK_8) )  g_cast_shadows   ^= 1; 
   if( get_key(SDLK_9) )  g_soft_shadows   ^= 1;
	 if( get_key(SDLK_0) )  g_show_rects   ^= 1;

	 if( get_key(SDLK_w) )  if( g_num_recursions < MAX_REF ) g_num_recursions++;
	 if( get_key(SDLK_q) )  if( g_num_recursions > 0 ) g_num_recursions--;

	 if( get_key(SDLK_e) )  if( g_quality_parameter < 128 ) g_quality_parameter++;
	 if( get_key(SDLK_r) )  if( g_quality_parameter > 1   ) g_quality_parameter--;

	 if( get_key(SDLK_t) ) g_animate ^= 1;


// Navigation controls:
if(g_Keys[SDLK_LSHIFT]) nav_scale( &g_my_nav, 2.0); else nav_scale( &g_my_nav, 1.0);

if(!g_Keys[SDLK_LALT])
{
 if(g_Keys[SDLK_RIGHT]) nav_follow( &g_my_nav, SCREEN_X/2 + SCREEN_X/4.0, SCREEN_Y/2, .2 );
 if(g_Keys[SDLK_LEFT])  nav_follow( &g_my_nav, SCREEN_X/2 - SCREEN_X/4.0, SCREEN_Y/2, .2 );
 if(g_Keys[SDLK_UP])    nav_follow( &g_my_nav, SCREEN_X/2, SCREEN_Y/2 + SCREEN_Y/4.0, .2 );
 if(g_Keys[SDLK_DOWN])  nav_follow( &g_my_nav, SCREEN_X/2, SCREEN_Y/2 - SCREEN_Y/4.0, .2 );
}
 else
{
 if(g_Keys[SDLK_RIGHT]) nav_strife( &g_my_nav,  1, 0, 0, .3 );
 if(g_Keys[SDLK_LEFT])  nav_strife( &g_my_nav, -1, 0, 0, .3 );
 if(g_Keys[SDLK_UP])    nav_strife( &g_my_nav,  0, 1, 0, .3 );
 if(g_Keys[SDLK_DOWN])  nav_strife( &g_my_nav,  0,-1, 0, .3 );
}

if(g_Keys[SDLK_a]) nav_accelerate( &g_my_nav, .05 );
if(g_Keys[SDLK_z]) nav_decelerate( &g_my_nav, .05 );

nav_move( &g_my_nav );
nav_friction( &g_my_nav, .1 );


}
while(!g_quit);


scene_free( &g_my_scene, 0, 0, 0, 0 );


SDL_Quit();

#ifdef DEBUG_LOG
 stop_log();
#endif

return 0;

}


