/*

 Ray 1.0 - Textures!

*/

#ifndef _TEXTURES
#define _TEXTURES





#include "SDL_image.h"
#include <string.h>


#define MAX_NUM_IMAGES 64


SDL_Surface  *g_my_image[ MAX_NUM_IMAGES ];  // SDL image handler
__int32   *g_my_textures[ MAX_NUM_IMAGES ];
char *g_my_texture_names[ MAX_NUM_IMAGES ];
int   g_num_textures = 0;




void load_textures(char *image_file[], int num)
{

 for(int i = 0; i < num; i++)
 {
  if( g_num_textures >= MAX_NUM_IMAGES ) return;

  g_my_image[ g_num_textures ] = IMG_Load( image_file[i] );
	 if( g_my_image[ g_num_textures ] == NULL ) return;

	g_my_textures[i] = (__int32*)malloc( 256*256 * sizeof(__int32) );
	 if(g_my_textures[i] == NULL) return;

	 {
	  __int32 *dest = g_my_textures[i];
	  unsigned char *src = (unsigned char *)g_my_image[i]->pixels;
	  for(int off = 0; off < 256*256; off++)
		{
	   int r, g, b;
	    r = *src++;
			g = *src++;
      b = *src++;
		  *dest = RGB2INT(r, g, b);
			dest++;
		}
	 }


	if( (g_my_texture_names[i] = (char*)malloc( strlen(image_file[i]) * sizeof(char))) != NULL )
		{
	   strcpy( g_my_texture_names[i], image_file[i] );
		}

  g_num_textures++;
 }

}


















void texture256_get_pixel(FIX_TYPE *r, FIX_TYPE *g, FIX_TYPE *b, 
													__int32 *txt, FIX_TYPE u, FIX_TYPE v)
{

__int32 col = *(txt + ( (u >> (FIX_BITS))&0xFF | (v >> (FIX_BITS-8))&0xFF00 ));

*r=(col>>8*2)&0xFF;
*g=(col>>8*1)&0xFF;
*b=col&0xFF;
}


/*
Bilinear interpolation of a 2D quad-cell:

 (1-xf)(1-yf) c1- - - - -c2 (xf)(1-yf)
              |    |      |
              |    yf     |
              |    |      |
              |--xf.      |
              |           |
   (1-xf)(yf) c3- - - - -c4 (xf)(yf)
 
*/
void texture256_get_pixel_B(FIX_TYPE *r, FIX_TYPE *g, FIX_TYPE *b, 
													__int32 *txt, FIX_TYPE u, FIX_TYPE v)
{
FIX_TYPE xf, yf;
__int32 *off;
FIX_TYPE c1, c2, c3, c4;
FIX_TYPE s1, s2, s3, s4;


xf = u >> (FIX_BITS-8);
yf = v >> (FIX_BITS-8);

off = txt + ( (u >> FIX_BITS)&0xFF | ( yf & 0xFF00 ) );


xf &= 0xFF;
yf &= 0xFF;

c1 = *off;
c2 = *(off + 1);
c3 = *(off + 256 + 1);
c4 = *(off + 256);

s3 = (xf * yf) >> 8;
s1 = 256 - xf - yf + s3;
s2 = xf - s3;
s4 = yf - s3;

*b = ((c1 & 0x0000FF)*s1 + 
		  (c2 & 0x0000FF)*s2 + 
		  (c3 & 0x0000FF)*s3 + 
		  (c4 & 0x0000FF)*s4  ) >> (8 + 8*0);

*g = ((c1 & 0x00FF00)*s1 +
		  (c2 & 0x00FF00)*s2 +
		  (c3 & 0x00FF00)*s3 +
		  (c4 & 0x00FF00)*s4  ) >> (8 + 8*1);

*r = (((c1 & 0xFF0000)>>2) * s1 +
      ((c2 & 0xFF0000)>>2) * s2 +
		  ((c3 & 0xFF0000)>>2) * s3 +
		  ((c4 & 0xFF0000)>>2) * s4) >> (8-2 + 8*2);

}








/*
int texture_create()
{
__int32 *t;

 t = (__int32 *)malloc(256*256 * sizeof(__int32) );

 if(t == NULL) return -1;

 g_my_textures[ g_num_textures ] = t;

int i, j;
int r,g,b;

for(j=0-128; j<256-128; j++)
 for(i=0-128; i<256-128; i++, t++)
 {
	 r = g = i^j;
   b = sin( (FTYPE)(i*i+j*j)*M_PI*8.0/(128.0*128.0) ) * 127.0+128;
	 *t = RGB2INT(r,g,b);
 }
 
 return g_num_textures++;
}
*/





#endif

