/*

 Ray 1.0 - Viewport handling functions

*/


#ifndef _LIB_VIEWPORT
#define _LIB_VIEWPORT


typedef struct {
 int w; // viewport width
 int h; // viewport height
  int w2, h2;
 t_vector3d *projectors; // projectors look-up [ linear buffer, size = ceil(w/2)*ceil(h/2) ]
 __int32 *vbuf; // destination linear image buffer
} t_viewport;



/////////////////////////



void init_viewport(t_viewport *vp, 
									 FTYPE ox, FTYPE oy, FTYPE oz, 
									 FTYPE x_min, FTYPE y_min,
                   FTYPE x_max, FTYPE y_max,
									 int w, int h, __int32 *vbuf)
{
int i, j;
float px, py, pz;
float dx, dy;
t_vector3d *p;

 vp->w = w;
 vp->h = h;
 vp->w2 = (int)(w / 2.0f + .5f);
 vp->h2 = (int)(h / 2.0f + .5f);

 p = vp->projectors = (t_vector3d *)malloc( (vp->w2+1) * (vp->h2+1) * sizeof(t_vector3d) );


//
// Setup Projectors:
//

 dx = (x_max - x_min) / (FTYPE)w;

 dy = (y_max - y_min) / (FTYPE)h;

 
 py = y_min;
 pz = oz;

for(j=0; j <= vp->h2; j++, py+=dy)
{
	px = x_min;

  for(i=0; i <= vp->w2; i++, px+=dx)
  {
   p->x = px;
	 p->y = py;
	 p->z = pz;
	 
   norm_v( p );

   p++;

  }
}


}





void get_projector(t_vector3d *dest, t_viewport *vp, int i, int j)
{

bool flip_x, flip_y;
flip_x = flip_y = false;

if( i > vp->w2 ) { i = vp->w - i; flip_x = true; }
if( j > vp->h2 ) { j = vp->h - j; flip_y = true; }

 t_vector3d *p = vp->projectors +  (i + j * (vp->w2+1));

 if( flip_x ) dest->x = - p->x; else dest->x = p->x;
 if( flip_y ) dest->y = - p->y; else dest->y = p->y;

 dest->z = p->z;
 
	/*
dest->x = (i - vp->w2)*(.5/SCREEN_X);
dest->y = (vp->h2 - j)*(.5/SCREEN_Y);
dest->z = 1;
norm_v( dest );
*/
}





#endif

